music('deepsparse.ogg')
r1 = huwalls([(0, 0), (300-PACKAGE/2, 0), 'packdoor', (300+PACKAGE/2, 0),
              (600, 0), (600, 150), 'outdoor', (600, 250), (600, 400),
            (0, 400)], closed=True, layer=LAYERABOVEGEOMS)
image(r1, image='level1-firstroom')

gasrect(rel=r1, rect=(0, 0, 600, 400))
controls(disable=['shoot_beam'])
controls(disable=['shoot_hook'])
controls(disable=['reel_in'])
controls(disable=['reel_out'])
controls(disable=['switch_gears'])
controls(disable=['shoot_bullet'])

r1d = door(r1, 'outdoor')
s1 = huswitch(pos=(0, 300), action=["set_flag('switchpushed', True)"])

p = player(pos=(100, 100+12-16), velo=(0, 0))

cpack = HuBox(payload=Circle(Player.PLAYERSIZE), rel=('top', r1),
                   pos=(300-PACKAGE/2, 0))

w = huwalls(['topdoor', (200, 0), (0, 0),
           (0, 44), 'balldoor-lt', (0, 88),
           (0, 600-88), 'balldoor-lb', (0, 600-44),  (0, 600),
           (800, 600), (800, 600-44), 'balldoor-rb', (800, 600-88),
           (800, 88), 'balldoor-rt', (800, 44),
           (800, 0), (300, 0)],
            counter=True, bg="level1-lastroom", closed=True, pos=(600, 500))
image(r1, image='level1-bend', offset=(600+THICKNESS, 150))
gasrect(rel=w, rect=(0, 0, 800, 600))

def moredrones():
    wtd.close()
    es = []
    for i in range(4):
        # vert or horiz?
        if randint(0, 1):
            # top or bottom?
            if randint(0, 1):
                y = 600
                yvel = -1
                mina = 45
                maxa = 135
            else:
                y = 0
                yvel = 1
                mina = 225
                maxa = 315
            x = randint(20, 800-20)
            xvel = randint(0, 5)
        else:
            # left or right?
            if randint(0, 1):
                x = 800
                xvel = -1
                mina = 135
                maxa = 225
            else:
                x = 0
                xvel = 1
                mina = 315
                maxa = 405
            y = randint(20, 600-20)
            yvel = randint(0, 5)
        t = place_target(pos=(x, y), dir=5*angle_vector(randint(mina, maxa)), time=3)
        es.append(t)
    add_action(KillAll(es), 'set_flag("allkilled", True)')

def initfunc():
    wtd.open()

s2 = switchrepeat(initfunc, moredrones, 'allkilled', dir=(0, 1),
                  goals=[ObjectIn(p, (600, 500, 800, 600))],
                  type=HuSwitch, pos=(200, 600), rel=w)
fx(w, 'bgrect', rect=(180, 600+THICKNESS, 40, 150))
corridor1 = huwalls([(600, 150), (900, 150), (900, 500)])
corridor2 = huwalls([(600, 250), (800, 250), (800, 500)], counter=True)

add_action(Flag('flashobj'), Repeat,
           'fx(get_flag("flashobj"), "flash", layer=LAYERGEOMS)',
           Ticks(10))

#door = walls([(201, 0), (299.5, 0)])
wtd = door(w, 'topdoor')
flag('switchpushed', meanwhile=Pattern([
    Dialog("Welcome to your first training session, Cadet." , characters.Lisa),
    Dialog("We haven't much time, but your craft, the Prometheus, is unlike what you've flown at the Academy. You'll need to get accustomed to it if you're to be of use. I just hope you'll have absorbed enough of the training before we reach the front lines.", characters.Lisa),
    Dialog("The Prometheus has standard rear-mounted propulsion systems. Apply them judiciously - in space, inertia carries you forever.", characters.Lisa),
    Dialog("You also have front-mounted retro-boosters. These will be useful for rapid deceleration and fine maneuvering.", characters.Lisa),
    Dialog("Fly around for a little while, get used to how it handles.", characters.Lisa),
    Dialog("Rotate clockwise with the %s key, and counterclockwise with the %s." % (get_control('rotate_right'), get_control('rotate_left'))),
    Dialog("Apply forward thrust by pressing %s." % (get_control('accel'))),
    Dialog("Fire the retro-booster by pressing %s." % (get_control('retro'))),
    Dialog("Don't be afraid to hit the walls - the Prometheus is designed for operating in tight quarters, and can take a few bumps.", characters.Lisa),
    Seconds(1),
    "controls(enable=['switch_gears'])",
    Dialog("To fit the varied maneuverability demands of space flight and combat, the Prometheus comes with two gears. One provides faster acceleration, but less direct control; the other provides more stable control, but a considerably slower acceleration.", characters.Lisa),
    Dialog("Press %s to switch gears. A flag on your health bar indicates which gear you're currently in." % (get_control('switch_gears'))),
    Training("switch_gears", None),
    Dialog("There's a switch on the west side of the room. When you're ready to move on, just bounce off of it.", characters.Lisa),
    "add_action(\"set_flag('flashobj', s1)\")"
    ]))

set_flag('flashobj', False)
start(s1, [((-2, 0), 10), ((0, 0), 0)])
fx(r1, 'bgrect', rect=(-40-THICKNESS, 250, 40, 100))
r1d.open()
wtd.open()

dialog("Head out the corridor on the other side of the room.", characters.Lisa)

objectin(p, (600, 500, 800, 600))
wtd.close()

controls(enable=['shoot_bullet'])
training("shoot", dict(bullet=bullettypes.Bullet, num=3), meanwhile=Sequence(
    Dialog("The ship is also armed with front-mounted positron pulse lasers. They are fully automatic with a rate of fire of about 45 per minute.", characters.Lisa),
    Dialog("Go ahead, fire a few rounds.", characters.Lisa),
    Dialog("You can activate your pulse lasers with the '%s' key. Holding down the key will fire as rapidly as possible." % (get_control('shoot_bullet'))),
    Dialog("We've filled the chamber with a gas that will react to the lasers; this will allow you to see the path your shots take. Knowing how the motion of your ship affects your shots is vital in space combat. ", characters.Lisa),
    ))

dialog("Looks like you have the hang of that, too.", characters.Lisa)

def place_target(pos, dir, time):
    return moving_replace(pos, dir, time,
                          Circle(12, rel=w),
                          Circle(12, rel=w, image="pinkball", health=1,
                                 radarcolor=(255, 0, 0), outanim='pinkball-death'))

dialog("We're going to place a few targets into the room. Shoot them down as fast as you can.", characters.Lisa)

dialog("Ready?", characters.Lisa)

b1 = place_target(pos=(0, 100), dir=(5, 0), time=3)
kills(b1, meanwhile=Dialog("Go!", characters.Lisa))

b2a = place_target(pos=(150, 600), dir=(0, -5), time=3)
b2b = place_target(pos=(650, 600), dir=(0, -5), time=3)
all(map(Kills, [b2a, b2b]))

b3a = place_target(pos=(800, 300), dir=(-5, 0), time=3)
b3b = place_target(pos=(0, 100), dir=(5, 0), time=3)
b3c = place_target(pos=(0, 500), dir=(5, 0), time=3)
all(map(Kills, [b3a, b3b, b3c]))

dialog("In the chaos of space battles, it's easy to lose track of the enemy. This is where your radar will be of use.", characters.Lisa)

b4a = place_target(pos=(400, 600), dir=(4, -3), time=5)
b4b = place_target(pos=(800, 300), dir=(-4, -3), time=5)
b4c = place_target(pos=(400, 0), dir=(-4, 3), time=5)
b4d = place_target(pos=(0, 300), dir=(4, 3), time=5)
all(map(Kills, [b4a, b4b, b4c, b4d]), meanwhile=Dialog("Red lines track your enemies. Blue, your projectiles. Green, enemy projectiles.", characters.Lisa))

waitn = 8
b5a = place_target(pos=(130, 600), dir=(0, -5), time=3)
ticks(waitn)
b5b = place_target(pos=(260, 600), dir=(0, -5), time=3)
ticks(waitn)
b5c = place_target(pos=(400, 600), dir=(0, -5), time=3)
ticks(waitn)
b5d = place_target(pos=(530, 600), dir=(0, -5), time=3)
ticks(waitn)
b5e = place_target(pos=(660, 600), dir=(0, -5), time=3)
ticks(waitn)
all(map(Kills, [b5a, b5b, b5c, b5d, b5e]))


set_flag("allkilled", True)
cpack, c = place(cpack)
delete(c)

dialog("Not bad.", characters.Lisa)
dialog("There's a switch on the wall that will send in more drones, if you want to hone your targeting skills.", characters.Lisa)
dialog("When you're done here, return to the first room; there's an entrance capsule there that will take you to the next training room.", characters.Lisa)
dialog("If you're having a hard time getting back into the capsule, remember that you can change gears with %s."%get_control("switch_gears"), characters.Lisa)
disable(cpack, 'bottom')
pd = door(r1, 'packdoor')
pd.open()

objectin(p, cpack.rect(), rel=cpack)
enable(cpack, 'bottom')
pd.close()
start(p, [((0, -10), 1)])
start(cpack, [((0, -10), 1)])

dialog("Let's move on.", characters.Lisa)
nextlevel = 'level2'
